<template>

	
	<v-card
		
	>	
		<v-toolbar
			dark
			color="brown"
			>

			<v-btn
			icon
			dark
			v-on:click.native="close"
			>
				<v-icon>mdi-close</v-icon>
			</v-btn>
			<v-toolbar-title class="title white--text pl-0">
				Selamat Datang di Crowd Funding Sahabat Kita!
			</v-toolbar-title>
		</v-toolbar>

		
		<v-card>
			<v-img
				height="225"
				src="https://images.unsplash.com/photo-1520961536084-445e75e10ee0?ixlib=rb-1.2.1&ixid=eyJhcHBfaWQiOjEyMDd9&auto=format&fit=crop&w=750&q=80">
					<v-app-bar flat color="rgba(0, 0, 0, 0)">            
						
						<v-spacer></v-spacer>

						<v-menu
							bottom
							offset-y
						>
							
						</v-menu>

					</v-app-bar>
			</v-img>	
			<v-card-title>
				Registration Form
			</v-card-title>

			<v-card-text>

				<v-form
					ref="form"
					v-model="valid"
					lazy-validation>

					<v-text-field
						v-model="name"
						:counter="50"
						:rules="nameRules"
						label="Name"
						required>
					</v-text-field>

					<v-text-field
						v-model="email"
						:rules="emailRules"
						label="E-mail"
						required>
					</v-text-field>

					<v-btn
						:disabled="!valid"
						color="success"
						class="mr-4"
						@click="validate">
						Submit
					</v-btn>

					<v-btn
						color="error"
						class="mr-4"
						@click="reset">
						Reset
					</v-btn>

				<alert/>

				</v-form>

			</v-card-text>
			<v-card-actions>


					<v-tooltip top>
						<template v-slot:activator="{ on1, attrs1 }">
							<v-btn icon class="mb-1 ml-2" v-on:click="$router.push({name:'auth.verification'})" >
								<v-icon large color="red darken-1" v-bind="attrs1" v-on="on1">mdi-account-check</v-icon>	
							</v-btn>		
						</template>
					<span>OTP Verification</span>
					</v-tooltip>

					<v-spacer></v-spacer>

					<v-tooltip top>
					<template v-slot:activator="{ on2, attrs2 }">
						<v-btn icon class="mb-1" v-on:click="$router.push({name:'auth.regenerateOtp'})" > 
							<v-icon large color="amber darken-1" v-bind="attrs2" v-on="on2">mdi-creation</v-icon>
						</v-btn>	
					</template>
					<span>OTP Regeneration</span>
					</v-tooltip>

					<v-spacer></v-spacer>

					<v-tooltip top>
					<template v-slot:activator="{ on3, attrs3 }">
						<v-btn icon class="mb-1 mr-2" v-on:click="$router.push({name:'auth.changePassword'})" > 
							<v-icon large color="green darken-1" v-bind="attrs3" v-on="on3">mdi-account-key</v-icon>
						</v-btn>	
					</template>
					<span>Change Password</span>
					</v-tooltip>
				
			</v-card-actions>					
		</v-card>
		
		        
    </v-card>
  	
</template>

<script>
import alert from '../../components/Alert.vue'
import {mapActions} from 'vuex' 

export default {

	components:{
		alert
	},
	data:function(){
		return{
			valid: true,
			name: '',
			nameRules: [
				v => !!v || 'Name is required',
				v => (v && v.length <= 50) || 'Name must be less than 50 characters',
			],
			email: '',
			emailRules: [
				v => !!v || 'E-mail is required',
				v => /.+@.+\..+/.test(v) || 'E-mail must be valid',
			],			  		
		}
	},methods:{
		async submit(){
			try {
				 let response = await axios.post('/api/auth/register', this.register())
				 
				 if(response.status == 200){

					let {response_message, response_code} = response.data
					
					if(response_code=="00"){
						this.show({
							title:'success',
							message: response_message,							
						})
					}else{
						this.show({
							title:'error',
							message: response_message,							
						})
					}

				 }
			} catch (e) {

				console.log(e.response);

				let {message, errors} = e.response.data
				
				console.log('Error is comming');
				console.log(errors);
				
				this.show({
							title:'error',
							message: message,
							theErrors : errors							
						})

			}
		},
		validate:function () {
			let isSuccessfullyValidated = this.$refs.form.validate()
			if(isSuccessfullyValidated){
				console.log(`the input parameter are: ${this.name} & ${this.email}`)
				this.submit()
			}else{
				console.log(`the problematic input parameter are: ${this.name} & ${this.email}`)

				this.message = 'Your input is not valid!'
				this.snackbar = true
				this.color = 'red'
			}
			
		},
		reset:function () {
			this.$refs.form.reset()
			this.$refs.form.resetValidation()
		},
		register:function(){
			return{
				name:this.name,
				email:this.email
			}
		},
		...mapActions({
		show:'alert/show'
		}),
		close:function(){
			this.$emit('closed',false)
		}

	},
	mounted: function(){
		console.log('Register Screen Mounted')
	},
	
}
</script>

<style>

</style>